"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _jsUtilReact = require("js-util/react");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

var _ValueList = require("./ValueList");

var _ValueList2 = _interopRequireDefault(_ValueList);

var _Ellipsis = require("./Ellipsis");

var _Ellipsis2 = _interopRequireDefault(_Ellipsis);

var _Primitive = require("./Primitive");

var _util = require("./util");

var toProp = function toProp(label, value) {
  return { label: label, value: value };
};

var toObjectProps = function toObjectProps(obj, max) {
  var toObjectProp = function toObjectProp(key) {
    return toProp(key, obj[key]);
  };
  var props = _ramda2["default"].pipe(_ramda2["default"].keys, _ramda2["default"].map(toObjectProp))(obj);
  if (max !== undefined) {
    props = withinBounds(props, max);
  }
  return props;
};

var toPrimitiveProps = function toPrimitiveProps(obj, max) {
  var isPrimitiveProp = function isPrimitiveProp(prop) {
    return (0, _Primitive.isPrimitive)(prop.value);
  };
  var props = _ramda2["default"].filter(isPrimitiveProp, toObjectProps(obj));
  props = withinBounds(props, max);
  if (_ramda2["default"].keys(obj).length > props.length && !_ramda2["default"].any(_ramda2["default"].equals(_ValueList.ELLIPSIS), props)) {
    props.push(_ValueList.ELLIPSIS);
  }
  return props;
};

var withinBounds = function withinBounds(array, max) {
  if (max === 0) {
    return [];
  }
  max = max === undefined ? array.length : max;
  var takeTotal = array.length === max ? array.length : max - 1;
  var items = _ramda2["default"].take(takeTotal, array);
  if (array.length > max) {
    if (max === 1) {
      items.push(_ramda2["default"].last(array));
      items.push(_ValueList.ELLIPSIS);
    } else {
      items.push(_ValueList.ELLIPSIS);
      items.push(_ramda2["default"].last(array));
    }
  }
  return items;
};

var toArrayProps = function toArrayProps(array, max) {
  // Add array items.
  var items = array.map(function (item, i) {
    return item === _ValueList.ELLIPSIS ? item : toProp(i.toString(), item);
  });
  items = withinBounds(items, max);

  // Add any properties on the array.
  var keys = _ramda2["default"].keys(array);
  var propKeys = _ramda2["default"].takeLast(keys.length - array.length, keys);
  propKeys.forEach(function (key) {
    return items.push(toProp(key, array[key]));
  });

  // Finish up.
  return items;
};

/**
 * A complex value (Object, Array).
 */

var Complex = (function (_React$Component) {
  _inherits(Complex, _React$Component);

  function Complex() {
    _classCallCheck(this, _Complex);

    _get(Object.getPrototypeOf(_Complex.prototype), "constructor", this).apply(this, arguments);
  }

  // API -------------------------------------------------------------------------

  _createClass(Complex, [{
    key: "styles",
    value: function styles() {
      return (0, _jsUtilReact.css)({
        base: {
          cursor: this.props.onClick ? "pointer" : null
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var styles = this.styles();
      var _props = this.props;
      var label = _props.label;
      var value = _props.value;
      var isExpanded = _props.isExpanded;
      var italic = _props.italic;
      var size = _props.size;
      var level = _props.level;

      var textStyles = { italic: italic, size: size };
      var isArray = _ramda2["default"].is(Array, value);
      var braceMargin = 0;
      if (isExpanded && (0, _util.isEmptyObjectOrArray)(value)) {
        isExpanded = false;
      }

      // Prepare the label.
      if (label === true) {
        // Only show labels for custom object names (eg. Classes).
        label = value.constructor.name;
        if (_ramda2["default"].any(_ramda2["default"].equals(label), ["Object", "Array"])) {
          label = null;
        }
      }
      var elLabel = label && _react2["default"].createElement(
        _Text2["default"],
        _extends({}, textStyles, { marginRight: 4 }),
        label
      );
      var openChar = isArray ? "[" : "{";
      var closeChar = isArray ? "]" : "}";

      // Prepare the value content.
      var elContent = undefined;
      if (isExpanded) {
        // -- Expanded --.
        var items = isArray ? toArrayProps(value, 5) : toObjectProps(value, 50);
        elContent = _react2["default"].createElement(_ValueList2["default"], _extends({
          items: items,
          level: level,
          collapsedTotal: this.props.collapsedTotal
        }, textStyles));
      } else {

        // -- Collapsed --.
        if (isArray && value.length > 0) {
          // Array: Show length, eg: "[2]".
          elContent = _react2["default"].createElement(
            _Text2["default"],
            _extends({ color: "grey" }, textStyles),
            value.length
          );
        } else {
          // Object: Show flat list of primitive props, eg: { foo:123 }.
          var totalProps = _ramda2["default"].keys(value).length;
          if (totalProps > 0) {
            var primitiveProps = toPrimitiveProps(value, this.props.collapsedTotal);
            var hasProps = primitiveProps.length > 0;
            braceMargin = hasProps ? 3 : 0;
            elContent = hasProps ? _react2["default"].createElement(_ValueList2["default"], _extends({
              items: primitiveProps,
              level: level,
              inline: true,
              collapsedTotal: this.props.collapsedTotal
            }, textStyles)) : _react2["default"].createElement(_Ellipsis2["default"], textStyles);
          }
        }
      }

      return _react2["default"].createElement(
        "span",
        { style: styles.base },
        elLabel,
        _react2["default"].createElement(
          _Text2["default"],
          _extends({}, textStyles, { marginRight: braceMargin }),
          openChar
        ),
        elContent,
        _react2["default"].createElement(
          _Text2["default"],
          _extends({}, textStyles, { marginLeft: braceMargin }),
          closeChar
        )
      );
    }
  }]);

  var _Complex = Complex;
  Complex = (0, _radium2["default"])(Complex) || Complex;
  return Complex;
})(_react2["default"].Component);

exports["default"] = Complex;
Complex.propTypes = {
  label: _jsUtilReact.PropTypes.boolOrString,
  value: _jsUtilReact.PropTypes.oneOfType([_jsUtilReact.PropTypes.object, _jsUtilReact.PropTypes.array]).isRequired,
  level: _jsUtilReact.PropTypes.number,
  isExpanded: _jsUtilReact.PropTypes.bool,
  collapsedStyle: _jsUtilReact.PropTypes.shape({ italic: _Text2["default"].propTypes.italic }),
  italic: _Text2["default"].propTypes.italic,
  size: _Text2["default"].propTypes.size,
  collapsedTotal: _jsUtilReact.PropTypes.number, // The number of {object} properties to show when not expanded.
  onClick: _jsUtilReact.PropTypes.func
};
Complex.defaultProps = {
  label: true,
  isExpanded: false,
  level: 0,
  italic: _Text2["default"].defaultProps.italic,
  size: _Text2["default"].defaultProps.size,
  collapsedTotal: 3
};
module.exports = exports["default"];