"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _jsUtilReact = require("js-util/react");

var FONT_MONO = "Menlo, monospace";
exports.FONT_MONO = FONT_MONO;
var COLORS = {
  black: "#000",
  darkGrey: "#303942",
  grey: "#999999",
  lightGrey: "#C8C8C8",
  red: "#C9214C",
  brown: "#9B4500",
  green: "#007500",
  blue: "#180AA9",
  purple: "#AC0093"
};

exports.COLORS = COLORS;
/**
 * Text display with commonly used style properties.
 */

var Text = (function (_React$Component) {
  _inherits(Text, _React$Component);

  function Text() {
    _classCallCheck(this, _Text);

    _get(Object.getPrototypeOf(_Text.prototype), "constructor", this).apply(this, arguments);
  }

  // API -------------------------------------------------------------------------

  _createClass(Text, [{
    key: "styles",
    value: function styles() {
      return (0, _jsUtilReact.css)({
        base: {
          fontFamily: FONT_MONO,
          fontSize: this.props.size,
          fontWeight: "normal",
          fontStyle: this.props.italic === true ? "italic" : "normal",
          lineHeight: this.props.lineHeight,
          color: COLORS[this.props.color],
          marginLeft: this.props.marginLeft,
          marginRight: this.props.marginRight,
          cursor: this.props.onClick ? "pointer" : null,
          letterSpacing: this.props.letterSpacing
        }
      });
    }
  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var onClick = this.props.onClick;

      if (onClick) {
        onClick({ args: e });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var styles = this.styles();
      var handleClick = this.handleClick.bind(this);
      return this.props.inline ? _react2["default"].createElement(
        "span",
        { style: styles.base, onClick: handleClick },
        this.props.children
      ) : _react2["default"].createElement(
        "div",
        { style: styles.base, onClick: handleClick },
        this.props.children
      );
    }
  }]);

  var _Text = Text;
  Text = (0, _radium2["default"])(Text) || Text;
  return Text;
})(_react2["default"].Component);

exports["default"] = Text;
Text.propTypes = {
  inline: _jsUtilReact.PropTypes.bool,
  italic: _jsUtilReact.PropTypes.bool,
  size: _jsUtilReact.PropTypes.numberOrString,
  color: _jsUtilReact.PropTypes.oneOf(Object.keys(COLORS)),
  marginLeft: _jsUtilReact.PropTypes.numberOrString,
  marginRight: _jsUtilReact.PropTypes.numberOrString,
  letterSpacing: _jsUtilReact.PropTypes.numberOrString,
  lineHeight: _jsUtilReact.PropTypes.numberOrString,
  onClick: _jsUtilReact.PropTypes.func
};
Text.defaultProps = {
  inline: true,
  italic: false,
  size: 12,
  color: "darkGrey",
  marginLeft: 0,
  marginRight: 0,
  letterSpacing: "normal",
  lineHeight: "1.4em"
};