"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _jsUtilReact = require("js-util/react");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

var _reactAtomsComponentsTwisty = require("react-atoms/components/Twisty");

var _reactAtomsComponentsTwisty2 = _interopRequireDefault(_reactAtomsComponentsTwisty);

var _Primitive = require("./Primitive");

var _Primitive2 = _interopRequireDefault(_Primitive);

var _Complex = require("./Complex");

var _Complex2 = _interopRequireDefault(_Complex);

var _Function = require("./Function");

var _Function2 = _interopRequireDefault(_Function);

var _Date = require("./Date");

var _Date2 = _interopRequireDefault(_Date);

var _util = require("./util");

/**
 * A single value of any type (with optional key and expansion toggle).
 */

var Value = (function (_React$Component) {
  _inherits(Value, _React$Component);

  function Value() {
    _classCallCheck(this, _Value);

    _get(Object.getPrototypeOf(_Value.prototype), "constructor", this).apply(this, arguments);
  }

  // API -------------------------------------------------------------------------

  _createClass(Value, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.setState({ isExpanded: this.props.isExpanded });
    }
  }, {
    key: "styles",
    value: function styles() {
      var _props = this.props;
      var inline = _props.inline;
      var value = _props.value;
      var isExpanded = this.state.isExpanded;

      var showTwisty = this.showTwisty();
      var twistyWidth = 10;
      var indent = showTwisty === true ? twistyWidth + 2 : 0;
      var canExpand = showTwisty && !isExpanded && !this.isPrimitive() && !(0, _util.isEmptyObjectOrArray)(value);

      return (0, _jsUtilReact.css)({
        base: {
          position: "relative",
          paddingLeft: indent,
          display: inline ? "inline-block" : null,
          marginLeft: this.props.marginLeft,
          marginRight: this.props.marginRight,
          cursor: canExpand ? "pointer" : null
        },
        twistyOuter: {
          Absolute: [0, null, null, 0],
          width: twistyWidth,
          fontSize: this.props.size,
          lineHeight: _Text2["default"].defaultProps.lineHeight
        },
        twistyAlign: {
          AbsoluteCenter: "y",
          width: twistyWidth
        }
      });
    }
  }, {
    key: "isPrimitive",
    value: function isPrimitive() {
      return (0, _Primitive.isPrimitive)(this.props.value);
    }
  }, {
    key: "showTwisty",
    value: function showTwisty() {
      var result = this.props.showTwisty;
      if (result === undefined) {
        var value = this.props.value;

        if (!(0, _Primitive.isPrimitive)(value) && !(0, _util.isEmptyObjectOrArray)(value)) {
          result = true;
        }
      }
      return result;
    }
  }, {
    key: "handleToggleClick",
    value: function handleToggleClick(e) {
      this.setState({ isExpanded: !this.state.isExpanded });
    }
  }, {
    key: "render",
    value: function render() {
      var styles = this.styles();
      var _props2 = this.props;
      var label = _props2.label;
      var italic = _props2.italic;
      var size = _props2.size;
      var value = _props2.value;
      var level = _props2.level;
      var isExpanded = this.state.isExpanded;

      var textStyles = { italic: italic, size: size };
      var isPrimitive = this.isPrimitive();
      var showTwisty = this.showTwisty();

      if ((0, _util.isEmptyObjectOrArray)(value)) {
        showTwisty = false;
      }

      var elTwisty = undefined,
          handleToggleClick = undefined;
      if (showTwisty === true && !isPrimitive) {
        handleToggleClick = this.handleToggleClick.bind(this);
        // NB: Add the "zero width non-joiner" (\u200C) character to force the
        //     height of the twisty container to the height of the label.
        elTwisty = _react2["default"].createElement(
          "div",
          { style: styles.twistyOuter },
          _react2["default"].createElement(
            "div",
            { style: styles.twistyAlign },
            _react2["default"].createElement(_reactAtomsComponentsTwisty2["default"], {
              isOpen: isExpanded,
              onClick: handleToggleClick
            })
          ),
          "‌"
        );
      }

      var elLabel = label && _react2["default"].createElement(
        _Text2["default"],
        _extends({
          color: "purple",
          onClick: handleToggleClick
        }, textStyles),
        label
      );

      var elValue = undefined;
      if (isPrimitive) {
        // Simple value (string, number, bool).
        elValue = _react2["default"].createElement(_Primitive2["default"], _extends({ value: value }, textStyles));
      } else {
        // Complex value (object, array).
        if (_ramda2["default"].is(Function, value)) {
          elValue = _react2["default"].createElement(_Function2["default"], _extends({}, textStyles, { value: value }));
        } else if (_ramda2["default"].is(Date, value)) {
          elValue = _react2["default"].createElement(_Date2["default"], _extends({}, textStyles, { value: value }));
        } else {
          elValue = _react2["default"].createElement(_Complex2["default"], _extends({}, textStyles, {
            value: value,
            level: level,
            label: level === 0,
            isExpanded: isExpanded,
            collapsedTotal: this.props.collapsedTotal
          }));
        }
      }

      return _react2["default"].createElement(
        "div",
        { style: styles.base, onClick: !isExpanded && handleToggleClick },
        elTwisty,
        elLabel,
        elLabel && _react2["default"].createElement(
          _Text2["default"],
          _extends({}, textStyles, { marginRight: 4 }),
          ":"
        ),
        elValue
      );
    }
  }]);

  var _Value = Value;
  Value = (0, _radium2["default"])(Value) || Value;
  return Value;
})(_react2["default"].Component);

exports["default"] = Value;
Value.propTypes = {
  value: _jsUtilReact.PropTypes.any,
  label: _jsUtilReact.PropTypes.string,
  italic: _Text2["default"].propTypes.italic,
  size: _Text2["default"].propTypes.size,
  inline: _jsUtilReact.PropTypes.bool,
  level: _jsUtilReact.PropTypes.number,
  isExpanded: _jsUtilReact.PropTypes.bool,
  showTwisty: _jsUtilReact.PropTypes.bool,
  marginLeft: _jsUtilReact.PropTypes.numberOrString,
  marginRight: _jsUtilReact.PropTypes.numberOrString,
  collapsedTotal: _jsUtilReact.PropTypes.number };
// The number of {object} properties to show when not expanded.
Value.defaultProps = {
  italic: _Text2["default"].defaultProps.italic,
  size: _Text2["default"].defaultProps.size,
  inline: false,
  level: 0,
  isExpanded: false,
  marginLeft: 0,
  marginRight: 0
};
module.exports = exports["default"];