"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _jsUtilReact = require("js-util/react");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

var _Ellipsis = require("./Ellipsis");

var _Ellipsis2 = _interopRequireDefault(_Ellipsis);

var Value = undefined; // NB: Lazily required to prevent circular-reference.

var ELLIPSIS = Symbol("ellipsis");

exports.ELLIPSIS = ELLIPSIS;
/**
 * A list of <Value>'s.
 */

var ValueList = (function (_React$Component) {
  _inherits(ValueList, _React$Component);

  function ValueList(props) {
    _classCallCheck(this, _ValueList);

    _get(Object.getPrototypeOf(_ValueList.prototype), "constructor", this).call(this, props);
    if (!Value) {
      Value = require("./Value");
    }
  }

  // API -------------------------------------------------------------------------

  _createClass(ValueList, [{
    key: "styles",
    value: function styles() {
      var inline = this.props.inline;

      return (0, _jsUtilReact.css)({
        base: {
          display: inline ? "inline-block" : null,
          listStyleType: "none",
          margin: 0,
          paddingTop: 0,
          paddingRight: 0,
          paddingBottom: 0,
          paddingLeft: inline ? 0 : "0.2em",
          fontSize: this.props.size,
          fontStyle: this.props.italic ? "italic" : "normal"
        },
        li: {
          display: this.props.inline ? "inline" : null
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var styles = this.styles();
      var _props = this.props;
      var inline = _props.inline;
      var size = _props.size;
      var italic = _props.italic;

      var textStyles = { italic: italic, size: size };
      var total = this.props.items.length;
      var items = [];
      this.props.items.forEach(function (item, i) {
        // Insert the <Value>.
        var isLast = i === total - 1;
        var isEllipsis = item === ELLIPSIS;
        var isNextEllipsis = _this.props.items[i + 1] === ELLIPSIS;
        var el = isEllipsis ? _react2["default"].createElement(_Ellipsis2["default"], _extends({}, textStyles, {
          marginLeft: inline ? isLast ? 0 : 6 : 12,
          marginRight: inline && !isLast ? 6 : 0 })) : _react2["default"].createElement(Value, _extends({}, textStyles, {
          label: item.label,
          value: item.value,
          level: _this.props.level + 1,
          isExpanded: false,
          inline: _this.props.inline,
          showTwisty: !inline,
          collapsedTotal: _this.props.collapsedTotal }));
        items.push(_react2["default"].createElement(
          "li",
          { key: i, style: styles.li },
          el
        ));

        // Inert dividing comma.
        if (inline && !isLast && !isEllipsis && !isNextEllipsis) {
          items.push(_react2["default"].createElement(
            _Text2["default"],
            _extends({
              key: i + "-comma"
            }, textStyles, {
              color: "darkGrey",
              marginRight: 8 }),
            ","
          ));
        }
      });

      return _react2["default"].createElement(
        "ul",
        { style: styles.base },
        items
      );
    }
  }]);

  var _ValueList = ValueList;
  ValueList = (0, _radium2["default"])(ValueList) || ValueList;
  return ValueList;
})(_react2["default"].Component);

exports["default"] = ValueList;
ValueList.propTypes = {
  inline: _jsUtilReact.PropTypes.bool,
  italic: _Text2["default"].propTypes.italic,
  size: _Text2["default"].propTypes.size,
  items: _jsUtilReact.PropTypes.array,
  level: _jsUtilReact.PropTypes.number,
  collapsedTotal: _jsUtilReact.PropTypes.number };
// The number of {object} properties to show when not expanded.
ValueList.defaultProps = {
  inline: false,
  italic: _Text2["default"].defaultProps.italic,
  size: _Text2["default"].defaultProps.size,
  items: [],
  level: 0
};