"use strict";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _componentsComplex = require("../components/Complex");

var _componentsComplex2 = _interopRequireDefault(_componentsComplex);

var _sections = require("./sections");

describe("Complex", function () {
  var _this = this;

  this.header("## A complex value (object, array).");
  before(function () {
    var value = {
      foo: 123,
      bar: "hello",
      baz: { number: -1 }
    };

    // value = []
    // value = [1,2,3];
    // value.foo = "hello";

    // fn: () => true
    _this.align("top left").scroll(true).load(_react2["default"].createElement(_componentsComplex2["default"], {
      value: value,
      isExpanded: false }));
  });

  section("label", function () {
    it("`true`", function () {
      return _this.props({ label: true });
    });
    it("`false`", function () {
      return _this.props({ label: false });
    });
    it("`'My Label'`", function () {
      return _this.props({ label: "My Label" });
    });
  });

  section("isExpanded", function () {
    it("`true`", function () {
      return _this.props({ isExpanded: true });
    });
    it("`false`", function () {
      return _this.props({ isExpanded: false });
    });
  });

  _sections.objectValueSection.call(this);
  _sections.arrayValueSection.call(this);

  _sections.italicSection.call(this);
  _sections.sizeSection.call(this);
  _sections.collapsedTotalSection.call(this);
});