"use strict";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _componentsValueList = require("../components/ValueList");

var _componentsValueList2 = _interopRequireDefault(_componentsValueList);

var _sections = require("./sections");

var DEFAULT_ITEMS = [{ label: "one", value: 1 }, {
  label: "two",
  value: {
    foo: ["foo", 2, new Date()],
    bar: function bar() {
      return true;
    }
  }
}, { label: "three", value: "toru" }, { label: "four" }, { label: "five", value: { simple: 1 } }, { label: "six", value: [] }, { label: "seven", value: {} }];

describe("ValueList", function () {
  var _this = this;

  this.header("## A list of values.");
  before(function () {
    _this.align("top left").load(_react2["default"].createElement(_componentsValueList2["default"], { items: DEFAULT_ITEMS }));
  });

  section("items", function () {
    it("`default`", function () {
      return _this.load(_react2["default"].createElement(_componentsValueList2["default"], { items: DEFAULT_ITEMS }));
    });
    it("`ellipsis` penultimate", function () {
      var items = [{ label: "one", value: 1 }, { label: "two", value: 2 }, _componentsValueList.ELLIPSIS, { label: "three", value: 3 }];
      _this.load(_react2["default"].createElement(_componentsValueList2["default"], { items: items }));
    });
    it("`ellipsis` last", function () {
      var items = [{ label: "one", value: 1 }, { label: "two", value: 2 }, _componentsValueList.ELLIPSIS];
      _this.load(_react2["default"].createElement(_componentsValueList2["default"], { items: items }));
    });
  });

  _sections.inlineSection.call(this);
  _sections.italicSection.call(this);
  _sections.sizeSection.call(this);
  _sections.collapsedTotalSection.call(this);
});