"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var array = function array(total) {
  return _ramda2["default"].repeat(null, total).map(function (item, i) {
    return i;
  });
};

var inlineSection = function inlineSection() {
  var _this = this;

  section("inline", function () {
    it("`inline: true`", function () {
      return _this.props({ inline: true });
    });
    it("`inline: false`", function () {
      return _this.props({ inline: false });
    });
  });
};

exports.inlineSection = inlineSection;
var italicSection = function italicSection() {
  var _this2 = this;

  section("italic", function () {
    it("`italic: true`", function () {
      return _this2.props({ italic: true });
    });
    it("`italic: false`", function () {
      return _this2.props({ italic: false });
    });
  });
};

exports.italicSection = italicSection;
var sizeSection = function sizeSection() {
  var _this3 = this;

  section("size", function () {
    it("`size: 12 (default)`", function () {
      return _this3.props({ size: 12 });
    });
    it("`size: 14`", function () {
      return _this3.props({ size: 14 });
    });
    it("`size: 16`", function () {
      return _this3.props({ size: 16 });
    });
    it("`size: 22`", function () {
      return _this3.props({ size: 22 });
    });
  });
};

exports.sizeSection = sizeSection;
var objectValueSection = function objectValueSection() {
  var _this4 = this;

  var MyClass = (function () {
    function MyClass(props) {
      _classCallCheck(this, MyClass);

      this.foo = "abc";
    }

    _createClass(MyClass, [{
      key: "bar",
      value: function bar() {
        return "hello";
      }
    }]);

    return MyClass;
  })();

  ;
  MyClass.number = 123;

  section("Object", function () {
    it("`{}`", function () {
      return _this4.props({ value: {} });
    });
    it("`{ foo, bar }`", function () {
      return _this4.props({ value: { foo: 123, bar: "hello" } });
    });
    it("`{ foo, bar ... }`", function () {
      return _this4.props({ value: { foo: 123, bar: "hello", baz: { number: -1 } } });
    });
    it("`{ 100 }`", function () {
      var value = {};
      array(100).forEach(function (i) {
        return value["prop" + i] = "value-" + i;
      });
      _this4.props({ value: value });
    });
    it("`MyClass{}`", function () {
      return _this4.props({ value: new MyClass() });
    });
    it("`complex`", function () {

      var value = {
        "1": 1,
        yes: true,
        no: false,
        text: "hello",
        "multi-part name": "value",
        number: -9999,
        date: new Date(),
        fn: function fn(p1, p2) {
          return true;
        },
        obj: {
          text: "foo",
          number: 123,
          child: {
            array: array(50)
          }
        },
        array: [1, "two", { three: 3 }]
      };

      _this4.props({ value: value });
    });
  });
};

exports.objectValueSection = objectValueSection;
var arrayValueSection = function arrayValueSection() {
  var _this5 = this;

  section("Array", function () {
    it("`[]`", function () {
      return _this5.props({ value: [] });
    });
    it("`[1, 2]`", function () {
      return _this5.props({ value: [1, 2] });
    });
    it("`['one', 2, { label:'three' }]`", function () {
      var value = ["one", 2, { label: "three" }];
      value.myProp = "foo";
      _this5.props({ value: value });
    });
    it("`[0..5]`", function () {
      return _this5.props({ value: array(5) });
    });
    it("`[0..100]`", function () {
      return _this5.props({ value: array(100) });
    });
  });
};

exports.arrayValueSection = arrayValueSection;
var functionValueSection = function functionValueSection() {
  var _this6 = this;

  var fn1 = function myFunc(param1, param2) {};
  var fn2 = function myFunc() {};
  section("Function", function () {
    it("`named with 2 params`", function () {
      return _this6.props({ value: fn1 });
    });
    it("`named with no params`", function () {
      return _this6.props({ value: fn2 });
    });
    it("`unnamed with 1 param`", function () {
      return _this6.props({ value: function value(p1) {
          return 0;
        } });
    });
    it("`unnamed with no params`", function () {
      return _this6.props({ value: function value() {
          return true;
        } });
    });
  });
};

exports.functionValueSection = functionValueSection;
var collapsedTotalSection = function collapsedTotalSection() {
  var _this7 = this;

  section("collapsedTotal", function () {
    it("`0`", function () {
      return _this7.props({ collapsedTotal: 0 });
    });
    it("`1`", function () {
      return _this7.props({ collapsedTotal: 1 });
    });
    it("`3`", function () {
      return _this7.props({ collapsedTotal: 3 });
    });
  });
};
exports.collapsedTotalSection = collapsedTotalSection;